Bug 55085 - UX Improvement : Ability to create New Test Plan from Templates
UX Improvement : Ability to create New Test Plan from Templates
Status: RESOLVED FIXED
Product: JMeter
Classification: Unclassified
Component: Main
2.9
All All
: P2 enhancement (vote)
: ---
Assigned To: JMeter issues mailing list
: PatchAvailable
Depends on:
Blocks: 55028
  Show dependency tree
 
Reported: 2013-06-09 12:22 UTC by UbikLoadPack support
Modified: 2013-08-03 12:43 UTC (History)
2 users (show)



Attachments
Patch implementing reported bug (38.52 KB, patch)
2013-06-09 12:31 UTC, UbikLoadPack support
Details | Diff
Screenshot of New menu (33.67 KB, image/png)
2013-06-09 13:14 UTC, UbikLoadPack support
Details
Screenshot of Create from Template Popup (44.92 KB, image/png)
2013-06-09 13:15 UTC, UbikLoadPack support
Details

Note You need to log in before you can comment on or make changes to this bug.
Description UbikLoadPack support 2013-06-09 12:22:23 UTC
Hello,
We implemented a new Menu Option called "New from Templates"
The idea is the following (similar to first step described in Bug 55028):
- User can select from a set of configurable templates one that fits his use case
- When he select create, the template is copied to the user.dir folder and opened in JMeter, user can modify it.


For now there is no GUI to create new template but it can be done through edition of templates.xml file.
Comment 1 UbikLoadPack support 2013-06-09 12:31:32 UTC
Created attachment 30421 [details]
Patch implementing reported bug

UBIK-INGENIERIE/UBIKLOADPACK grants the full rights to Apache to use the attached code and releases any rights associated to this patch.

Is there something else we need to send ?
Thanks
Comment 2 UbikLoadPack support 2013-06-09 13:14:52 UTC
Created attachment 30422 [details]
Screenshot of New menu
Comment 3 UbikLoadPack support 2013-06-09 13:15:30 UTC
Created attachment 30423 [details]
Screenshot of Create from Template Popup
Comment 4 Philippe Mouawad 2013-06-29 20:19:55 UTC
Date: Sat Jun 29 20:08:15 2013
New Revision: 1498018

URL: http://svn.apache.org/r1498018
Log:
Bug 55085 - UX Improvement : Ability to create New Test Plan from Templates
Bugzilla Id: 55085

Added:
    jmeter/trunk/bin/templates/
    jmeter/trunk/bin/templates/jdbc.jmx
    jmeter/trunk/bin/templates/recording.jmx
    jmeter/trunk/bin/templates/templates.xml   (with props)
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/SelectTemplateDialog.java   (with props)
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/TemplateCommand.java   (with props)
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/template/
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/template/Template.java   (with props)
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/template/TemplateManager.java   (with props)
Modified:
    jmeter/trunk/bin/jmeter.properties
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/ActionNames.java
    jmeter/trunk/src/core/org/apache/jmeter/gui/util/JMeterMenuBar.java
    jmeter/trunk/src/core/org/apache/jmeter/resources/messages.properties
    jmeter/trunk/src/core/org/apache/jmeter/resources/messages_fr.properties
    jmeter/trunk/xdocs/changes.xml


Date: Sat Jun 29 20:11:43 2013
New Revision: 1498019

URL: http://svn.apache.org/r1498019
Log:
Bug 55085 - UX Improvement : Ability to create New Test Plan from Templates
Set svn:eol-type
Bugzilla Id: 55085

Modified:
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/SelectTemplateDialog.java   (props changed)
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/TemplateCommand.java   (props changed)
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/template/Template.java   (props changed)
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/template/TemplateManager.java   (props changed)

Date: Sat Jun 29 20:19:02 2013
New Revision: 1498022

URL: http://svn.apache.org/r1498022
Log:
Bug 55085 - UX Improvement : Ability to create New Test Plan from Templates
Set svn properties
Bugzilla Id: 55085

Modified:
    jmeter/trunk/bin/templates/jdbc.jmx   (props changed)
    jmeter/trunk/bin/templates/recording.jmx   (props changed)
    jmeter/trunk/bin/templates/templates.xml   (props changed)
Comment 5 Philippe Mouawad 2013-06-29 20:20:15 UTC
Thanks applied.
Comment 6 Milamber 2013-06-30 17:34:57 UTC

If you run a ant distribution task, the "bin/templates" directory aren't include in archive (tar.gz). 
And you have this error message on GUI :
Sorry, this feature (create_from_template) not yet implemented

I think, this (great) feature needs some documentation in user manual.
Comment 7 Philippe Mouawad 2013-06-30 18:44:51 UTC
Date: Sun Jun 30 18:42:53 2013
New Revision: 1498168

URL: http://svn.apache.org/r1498168
Log:
Bug 55085 - UX Improvement : Ability to create New Test Plan from Templates
add templates to distribution
Bugzilla Id: 55085

Modified:
    jmeter/trunk/build.xml
Comment 8 Sebb 2013-07-06 00:39:28 UTC
The Menu item "New from Templates" does not check if the test plan has been saved before replacing it, so it is possible to lose edits.
Comment 9 Philippe Mouawad 2013-07-06 19:41:09 UTC
Date: Sat Jul  6 19:36:27 2013
New Revision: 1500318

URL: http://svn.apache.org/r1500318
Log:
Bug 55085 - UX Improvement : Ability to create New Test Plan from Templates
Fixed missing " check if the test plan has been saved before replacing it"
Bugzilla Id: 55085

Modified:
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/SelectTemplateDialog.java
    jmeter/trunk/src/core/org/apache/jmeter/resources/messages.properties
    jmeter/trunk/src/core/org/apache/jmeter/resources/messages_fr.properties
Comment 10 Philippe Mouawad 2013-07-08 20:04:50 UTC
Date: Mon Jul  8 19:59:52 2013
New Revision: 1500919

URL: http://svn.apache.org/r1500919
Log:
Bug 55085 - UX Improvement : Ability to create New Test Plan from Templates
Added documentation
Bugzilla Id: 55085

Modified:
    jmeter/trunk/xdocs/usermanual/get-started.xml


Date: Mon Jul  8 20:02:04 2013
New Revision: 1500922

URL: http://svn.apache.org/r1500922
Log:
Bug 55085 - UX Improvement : Ability to create New Test Plan from Templates
Added documentation
Bugzilla Id: 55085

Added:
    jmeter/trunk/xdocs/images/screenshots/template_menu.png   (with props)
    jmeter/trunk/xdocs/images/screenshots/template_wizard.png   (with props)


Date: Mon Jul  8 20:03:16 2013
New Revision: 1500924

URL: http://svn.apache.org/r1500924
Log:
Bug 55085 - UX Improvement : Ability to create New Test Plan from Templates
Added screenshot
Bugzilla Id: 55085

Added:
    jmeter/trunk/docs/images/screenshots/template_menu.png   (with props)
    jmeter/trunk/docs/images/screenshots/template_wizard.png   (with props)
Comment 11 Milamber 2013-07-09 08:55:35 UTC

If the Template dialog box has a landscape orientation, I think that would be better to read the description.


I think too, the first template in combo box must be the Recording template. (perhaps rename "01-Recording")
Comment 12 Sebb 2013-07-09 10:29:20 UTC
(In reply to Milamber from comment #11)
> 
> 
> I think too, the first template in combo box must be the Recording template.
> (perhaps rename "01-Recording")

Renaming won't work as they are stored in a HashMap.
Perhaps use LinkedHashMap? Or a List?
Also the method getTemplateNames needs to return a List or Array
Comment 13 Sebb 2013-07-09 11:00:28 UTC
(In reply to Sebb from comment #12)
> (In reply to Milamber from comment #11)
> > 
> > 
> > I think too, the first template in combo box must be the Recording template.
> > (perhaps rename "01-Recording")
> 
> Renaming won't work as they are stored in a HashMap.
> Perhaps use LinkedHashMap? Or a List?
> Also the method getTemplateNames needs to return a List or Array

Sorry, had overlooked the sort in SelectTemplateDialog.

However, I think it would be better to allow the template provider to specify the ordering within the xml files; i.e. the correct order should be returned by getTemplateNames.
Comment 14 Sebb 2013-07-09 12:52:07 UTC
URL: http://svn.apache.org/r1501226
Log:
UX Improvement : Ability to create New Test Plan from Templates
TemplateManager now returns templates in the order they are defined
Bugzilla Id: 55085

URL: http://svn.apache.org/r1501228
Log:
UX Improvement : Ability to create New Test Plan from Templates
Document why we don't use interface type Map for Templates#templates
Bugzilla Id: 55085
Comment 15 Sebb 2013-07-09 13:05:05 UTC
URL: http://svn.apache.org/r1501238
Log:
UX Improvement : Ability to create New Test Plan from Templates
Change preferred size so existing templates fit better
Bugzilla Id: 55085

Modified:
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/SelectTemplateDialog.java
Comment 16 Milamber 2013-07-09 15:14:09 UTC
URL: http://svn.apache.org/r1501297
Log:
UX Improvement : Ability to create New Test Plan from Templates
Simplify swing objects. Let's ComponentUtil sizing the dialog box.
Bugzilla Id: 55085

Modified:
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/SelectTemplateDialog.java
Comment 17 Philippe Mouawad 2013-07-10 20:56:30 UTC
Date: Wed Jul 10 20:55:39 2013
New Revision: 1501989

URL: http://svn.apache.org/r1501989
Log:
Bug 55085 - UX Improvement : Ability to create New Test Plan from Templates
Handle opening of browser on link clicking
Bugzilla Id: 55085

Modified:
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/SelectTemplateDialog.java
Comment 18 Milamber 2013-07-21 11:15:45 UTC
URL: http://svn.apache.org/r1505338
Log:
UX Improvement : Ability to create New Test Plan from Templates
Rename "Create from templates" to Templates (internally)
Bugzilla Id: 55085

Added:
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/SelectTemplatesDialog.java   (contents, props changed)
      - copied, changed from r1505328, jmeter/trunk/src/core/org/apache/jmeter/gui/action/SelectTemplateDialog.java
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/TemplatesCommand.java   (contents, props changed)
      - copied, changed from r1505328, jmeter/trunk/src/core/org/apache/jmeter/gui/action/TemplateCommand.java
Removed:
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/SelectTemplateDialog.java
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/TemplateCommand.java
Modified:
    jmeter/trunk/src/core/org/apache/jmeter/gui/action/ActionNames.java
    jmeter/trunk/src/core/org/apache/jmeter/gui/util/JMeterMenuBar.java
    jmeter/trunk/src/core/org/apache/jmeter/resources/messages.properties
    jmeter/trunk/src/core/org/apache/jmeter/reso
Comment 19 Milamber 2013-07-21 11:19:51 UTC
URL: http://svn.apache.org/r1505341
Log:
UX Improvement : Ability to create New Test Plan from Templates
Add icon's templates to bar menu
Bugzilla Id: 55085

Added:
    jmeter/trunk/src/core/org/apache/jmeter/images/toolbar/templates.png   (with props)
Modified:
    jmeter/trunk/src/core/org/apache/jmeter/images/toolbar/icons-toolbar.properties
Comment 20 Philippe Mouawad 2013-08-03 12:43:06 UTC
Date: Sat Aug  3 12:41:36 2013
New Revision: 1509971

URL: http://svn.apache.org/r1509971
Log:
Bug 55085 - UX Improvement : Ability to create New Test Plan from Templates
Add Webservice Template (not using deprecated Webservice Sampler)
Enhance web test plan to show more features
Bugzilla Id: 55085

Added:
    jmeter/trunk/bin/templates/build-webservice-test-plan.jmx
Modified:
    jmeter/trunk/bin/templates/build-web-test-plan.jmx
    jmeter/trunk/bin/templates/templates.xml